<?php

/**
 * Implementiert die Einstellung  der zeitrelevante Parameter
 * @author Miguel Palmer <mp@beronet.com>
 */

include_once('/usr/www/include/SQLite2ToSQLite3.php');

class TimeConf {

	private		$m_attr;

	private 	$isIsgwLoginFailed = 0;

	private		$isRequestRejected = 0,
			$reasonRejected = array();

	private		$default = array();

	private		$showDate = 0;
	/**
	 * Constructor
	 */
	function __construct($m, $get = array(), $post = array(), $session = array()) {
		$this->m_attr = $m;
		$this->default['timezone_val'] = Helper::getTimezoneList();
		$this->showDate = (isset($get['showDate']) && $get['showDate'] == 1) ? 1 : 0;
		unset($get['showDate']);		

		// isgw failed to start
		if (isset($get['errorisgw'])) {
			$this->isIsgwLoginFailed = 1;
			unset($get['errorisgw']);
		}
                // get error from modal or submit execution
                else if (isset($get['error'])) {
                        $this->isRequestRejected = 1;
                        $this->reasonRejected = array('request' => $get['request'], 'checkor' => $get['checkor'], 'key' => $get['key']);
                        unset($get['error'], $get['request'], $get['checkor'], $get['key']);
                }
	}
	
	/**
	 * Generates the timezone otions
	 * @return string
	 */
	function options() {
		$bc = new beroConf('root');
		$arr_text = array("(GMT -12:00) Eniwetok, Kwajalein", "(GMT -11:00) Midway Island, Samoa",
			"(GMT -10:00) Hawaii", "(GMT -9:00) Alaska", "(GMT -8:00) Pacific Time (US &amp; Canada)",
			"(GMT -7:00) Mountain Time (US &amp; Canada)", "(GMT -6:00) Central Time (US &amp; Canada), Mexico City",
			"(GMT -5:00) Eastern Time (US &amp; Canada), Bogota, Lima", "(GMT -4:00) Atlantic Time (Canada), Caracas, La Paz",
			"(GMT -3:30) Newfoundland", "(GMT -3:00) Brazil, Buenos Aires, Georgetown",
			"(GMT -2:00) Mid-Atlantic", "(GMT -1:00 hour) Azores, Cape Verde Islands",
			"(GMT) Western Europe Time, London, Lisbon, Casablanca", "(GMT +1:00) Berlin, Brussels, Copenhagen, Madrid, Paris",
			"(GMT +2:00) Kaliningrad, South Africa", "(GMT +3:00) Baghdad, Riyadh, Moscow, St. Petersburg",
			"(GMT +3:30) Tehran", "(GMT +4:00) Abu Dhabi, Muscat, Baku, Tbilisi",
			"(GMT +4:30) Kabul", "(GMT +5:00) Ekaterinburg, Islamabad, Karachi, Tashkent",
			"(GMT +5:30) Bombay, Calcutta, Madras, New Delhi", "(GMT +5:45) Kathmandu",
			"(GMT +6:00) Almaty, Dhaka, Colombo", "(GMT +7:00) Bangkok, Hanoi, Jakarta",
			"(GMT +8:00) Beijing, Perth, Singapore, Hong Kong", "(GMT +9:00) Tokyo, Seoul, Osaka, Sapporo, Yakutsk",
			"(GMT +9:30) Adelaide, Darwin", "(GMT +10:00) Eastern Australia, Guam, Vladivostok",
			"(GMT +11:00) Magadan, Solomon Islands, New Caledonia", "(GMT +12:00) Auckland, Wellington, Fiji, Kamchatka");

		$arr_val = $this->default['timezone_val'];

		$sp = $bc->get("root", "timezone");
		$options = "";
		for ($i = 0; $i < count($arr_val); $i++) {
			($arr_val[$i] == $sp) ? $selected = "selected" : $selected = "";
			$options .= "<option value='" . $arr_val[$i] . "' " . $selected . ">" . $arr_text[$i] . "</option>";
		}
		return $options;
	}

	/**
	 * Generates the options for the time from isdn dropdown menu
	 * @return string
	 */
	function ports($def = 0) {
		$ba = new beroAri();
		$options = "<option value='no'>Disabled</option>";
		$query = $ba->select("select port from isdn");
		while ($ports = $ba->fetch_array($query)) {
			if ($def == $ports['port']) {
				$options .= "<option value='" . $ports['port'] . "' selected>Port " . $ports['port'] . "</option>";
			} else {
				$options .= "<option value='" . $ports['port'] . "'>Port " . $ports['port'] . "</option>";
			}
		}
		return $options;
	}

	/**
	 * Generates the HTML page
	 * @return string
	 */
	function display() {

		include '/usr/fallback/beroConf.php';
		$bc = new beroConf('root');
		$ba = new beroAri();

		$name = "TIME_TITLE_DIS";
		include('./includes/header.php');
		require_once("./includes/lang.php");

		// args
		$m = $this->m_attr;
		if (!$bc->valid()) {
			$ret .= '<h3>Error:</h3><b>Failed to connect to config database!</b><br>';
			exit(0);
		}
		
		if ($this->showDate) {
			$ret .= "<br/><div class='text-center'>" . Helper::getDate() . "</div><br/>";
		}

		// get isgw login from submit
		if ($this->isIsgwLoginFailed) {
			$ret .= "<div class='text-center' style='color:red;'>".STATE_ISWG_ERROR_DIS."</div>";
		}
		// check request
		else if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		if ($ba->get('gui_mode') == 'simple') {
			$simple_class = 'simple';
		}
		if ($ba->get("summer_winter_time") == "1" || $ba->get("summer_winter_time") == "yes") {
			$summerTime = "checked";
		}
		ob_start();
		?>

		<script>
		    function tfi(ch) {
		        if (ch != 0) {
		            document.getElementById('ntphost').style.display = 'none';
		            document.getElementById('tz').style.display = 'none';
		            document.getElementById('summer_winter').style.display = 'none';
		        } else {
		            document.getElementById('ntphost').style.display = '';
		            document.getElementById('tz').style.display = '';
		            document.getElementById('summer_winter').style.display = '';
		        }

		    }
		</script>
		<br>
		<form  name="timeform" id="timeform" class="form-horizontal" method="POST" action="modules/TimeConf/timeconf_submit.php">
			<input type="hidden" name="action" value="save">
			<p class="text-center lead" ><?php echo TIME_TABLE_HEADER_DIS ?></p>

			
			<?php
				$ntp_hover = "";
				$ntp_asterisk = "";
				$gui_ntp_host = $bc->get("root", "gui-ntphost");
				if (!strlen ($gui_ntp_host)) {
					$ntp_host = $bc->get("root", "ntphost");
					if (strlen ($ntp_host)) {
						$ntp_asterisk = "<span style=color:red>*</span>";
						$ntp_hover = "onmouseover='Tip(\"" . "Using default NTP: " . $ntp_host ."\"" . ")' onmouseout='UnTip()'";
					}
				}
				
			?>
			<div class='form-group' id="ntphost">
				<label  <?php echo $ntp_hover ?> for='ntphost' class='col-sm-5 control-label'><?php echo TIME_NTP_HOST_DIS . $ntp_asterisk ?></label>
				<div class='col-sm-4'>
					<input name="ntphost" <?php echo $ntp_hover ?> class="form-control input-sm" type="text" size="15" id="ntphost" value="<?php echo $gui_ntp_host ?>">
				</div>
			</div>
			
			<div class='form-group' id="tz">
				<label for='timezone' class='col-sm-5 control-label'><?php echo TIME_TIMEZONE_DIS ?></label>
				<div class='col-sm-4'>
					<select name="timezone" class="form-control input-sm" id="timezone">
						<?php echo $this->options() ?>
					</select>
				</div>
			</div>
			<div class='form-group' id="summer_winter">
				<label for='summer_winter_time' class='col-sm-5 control-label'><?php echo TIME_SUMMER_WINTER_DIS ?></label>
				<div class='col-sm-4 form-checkbox'>
					<input type="hidden" name="summer_winter_time" id="summer_winter_time" value="0">
					<input type="checkbox" name="summer_winter_time" id="summer_winter_time" value="1" <?php echo $summerTime ?>>
				</div>
			</div>

			<div class="form-group <?php echo $simple_class ?>" >
				<label for='time_from_isdn' class='col-sm-5 control-label'><?php echo TIME_TIME_FROM_ISDN_DIS ?></label>
				<div class='col-sm-4'>
					<select name="time_from_isdn" class="form-control input-sm" id="time_from_isdn" 
							onclick="tfi(time_from_isdn.selectedIndex);">
								<?php echo $this->ports($bc->get("root", "time_from_isdn")) ?>
					</select>
				</div>
			</div>
			<br>
			<div class="text-center">
				<input type="submit" class="btn btn-default" name="Apply" value="<?php echo BUTTON_SAVE ?>">
			</div>
		</form>
		<script>
		    $("#timeform").validate({

		        rules: {
		            ntphost: {
		                checkHostname: true,
		            },
		        }
		    });
		    tfi(document.getElementById("time_from_isdn").selectedIndex);
		</script>
		<?php
		$ret .= ob_get_clean();

		return $ret;
	}

}
?>
